Loading...
Searching...
No Matches
casacore::UnaryFunction< T > Class Template Reference
scimath package (libcasa_scimath) » Functionals_module

More...

`#include <UnaryFunction.h>`

## Public Member Functions

| UnaryFunction ()
| Constructs the UnaryFunction, Defaults: height=1, center=0, width=1.
| UnaryFunction (const T &height)
| UnaryFunction (const T &height, const T &center)
| UnaryFunction (const T &height, const T &center, const T &width)
| UnaryFunction (const UnaryFunction< T > &other)
| Copy constructor (deep copy).
template<class W>
| UnaryFunction (const UnaryFunction< W > &other)
UnaryFunction< T > & | operator= (const UnaryFunction< T > &other)
| Copy assignment (deep copy).
virtual | ~UnaryFunction ()
| Destructor.
virtual T | eval (typename Function< T >::FunctionArg x) const
| Evaluate the Unary at x.
virtual Function< T > * | clone () const
| Return a copy of this object from the heap.
virtual Function< typename FunctionTraits< T >::DiffType > * | cloneAD () const
virtual Function< typename FunctionTraits< T >::BaseType > * | cloneNonAD () const
Public Member Functions inherited from casacore::UnaryParam< T >
| UnaryParam ()
| Constructs the Unary, Defaults: height=1, center=0, width=1.
| UnaryParam (const T &height)
| UnaryParam (const T &height, const T &center)
| UnaryParam (const T &height, const T &center, const T &width)
| UnaryParam (const UnaryParam< T > &other)
| Copy constructor (deep copy).
template<class W>
| UnaryParam (const UnaryParam< W > &other)
UnaryParam< T > & | operator= (const UnaryParam< T > &other)
| Copy assignment (deep copy).
virtual | ~UnaryParam ()
| Destructor.
virtual uInt | ndim () const
| Returns the number of dimensions of function.
virtual const String & | name () const
| Give name of function.
Public Member Functions inherited from casacore::Function< T, U >
| Function ()
| Constructors.
| Function (const uInt n)
| Function (const Vector< T > &in)
| Function (const FunctionParam< T > &other)
template<class W, class X>
| Function (const Function< W, X > &other)
virtual | ~Function ()
| Destructor.
uInt | nparameters () const
| Returns the number of parameters.
virtual U | eval (FunctionArg x) const =0
| Evaluate the function object.
T & | operator[] (const uInt n)
| Manipulate the nth parameter (0-based) with no index check.
const T & | operator[] (const uInt n) const
virtual U | operator() () const
| Evaluate this function object at xor at x, y.
virtual U | operator() (const ArgType &x) const
virtual U | operator() (const Vector< ArgType > &x) const
virtual U | operator() (FunctionArg x) const
virtual U | operator() (const ArgType &x, const ArgType &y) const
virtual U | operator() (const ArgType &x, const ArgType &y, const ArgType &z) const
Bool & | mask (const uInt n)
| Manipulate the mask associated with the nth parameter (e.g.
const Bool & | mask (const uInt n) const
const FunctionParam< T > & | parameters () const
| Return the parameter interface.
FunctionParam< T > & | parameters ()
const Vector< ArgType > & | argp () const
| Get arg_p and parset_p.
Bool | parsetp () const
void | lockParam ()
| Compiler cannot always find the correct 'const' version of parameter access.
void | unlockParam ()
virtual void | setMode (const RecordInterface &mode)
| get/set the function mode.
virtual void | getMode (RecordInterface &mode) const
virtual Bool | hasMode () const
| return True if the implementing function supports a mode.
ostream & | print (ostream &os) const
| Print the function (i.e.
Public Member Functions inherited from casacore::Functional< FunctionTraits< T >::ArgType, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const FunctionTraits< T >::ArgType &x) const=0
| Map a Domain x into a Range y value.
Public Member Functions inherited from casacore::Functional< Vector< FunctionTraits< T >::ArgType >, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const Vector< FunctionTraits< T >::ArgType > &x) const=0
| Map a Domain x into a Range y value.

## Additional Inherited Members

Public Types inherited from casacore::UnaryParam< T >
enum | { HEIGHT , CENTER , WIDTH }
| Parameter numbers. More...
Public Types inherited from casacore::Function< T, U >
typedef FunctionTraits< T >::ArgType | ArgType
typedef const ArgType * | FunctionArg
Protected Attributes inherited from casacore::Function< T, U >
FunctionParam< T > | param_p
| The parameters and masks.
Vector< ArgType > | arg_p
| Aid for non-contiguous argument storage.
Bool | parset_p
| Indicate parameter written.
Bool | locked_p
| Indicate that parameters are expected to be locked from changing.

## Detailed Description

template<class T>
class casacore::UnaryFunction< T >

A one dimensional unary function

### Intended use:

Public interface

### Review Status

Test programs:
  tFunctionHolder

### Prerequisite

- UnaryParam
- Function

### Etymology

A 1-dimensional unary hat.

### Synopsis

A Unary is described by a height, a center and a width (halfwidth). The value is:

height (|x-center| < width)
0.5height (|x-center| == width)
0 (|x-center| > width)

The parameters are enumerated by HEIGHT, CENTER and WIDTH. They have default values of (1, 0, 1).

### Example

UnaryFunction<Double> sf(5.0, 25.0, 7);
sf(25); // = 5.0
casacore::UnaryFunction::UnaryFunction
UnaryFunction()
Constructs the UnaryFunction, Defaults: height=1, center=0, width=1.
Definition UnaryFunction.h:93

### Template Type Argument Requirements (T)

- T should have standard numerical operators

### Thrown Exceptions

- AipsError if incorrect parameter number specified.

Definition at line 84 of file UnaryFunction.h.

## Constructor & Destructor Documentation

## UnaryFunction() [1/6]

template<class T>

casacore::UnaryFunction< T >::UnaryFunction | ( |  | ) |

inline

Constructs the UnaryFunction, Defaults: height=1, center=0, width=1.

Warning: Could not use default arguments that worked both with gcc and IRIX

Definition at line 93 of file UnaryFunction.h.

References casacore::UnaryParam< T >::UnaryParam().

Referenced by clone(), cloneAD(), cloneNonAD(), operator=(), UnaryFunction(), and UnaryFunction().

## UnaryFunction() [2/6]

template<class T>

casacore::UnaryFunction< T >::UnaryFunction | ( | const T & | height | ) |

inline explicit

Definition at line 94 of file UnaryFunction.h.

References casacore::UnaryParam< T >::UnaryParam().

## UnaryFunction() [3/6]

template<class T>

casacore::UnaryFunction< T >::UnaryFunction | ( | const T & | height,
|  | const T & | center )

inline

Definition at line 96 of file UnaryFunction.h.

References casacore::UnaryParam< T >::UnaryParam().

## UnaryFunction() [4/6]

template<class T>

casacore::UnaryFunction< T >::UnaryFunction | ( | const T & | height,
|  | const T & | center,
|  | const T & | width )

inline

Definition at line 98 of file UnaryFunction.h.

References casacore::UnaryParam< T >::UnaryParam().

## UnaryFunction() [5/6]

template<class T>

casacore::UnaryFunction< T >::UnaryFunction | ( | const UnaryFunction< T > & | other | ) |

inline

Copy constructor (deep copy).

Definition at line 104 of file UnaryFunction.h.

References UnaryFunction(), and casacore::UnaryParam< T >::UnaryParam().

## UnaryFunction() [6/6]

template<class T>
template<class W>

casacore::UnaryFunction< T >::UnaryFunction | ( | const UnaryFunction< W > & | other | ) |

inline

Definition at line 106 of file UnaryFunction.h.

References UnaryFunction(), and casacore::UnaryParam< T >::UnaryParam().

## ~UnaryFunction()

template<class T>

virtual casacore::UnaryFunction< T >::~UnaryFunction | ( |  | ) |

inline virtual

Destructor.

Definition at line 113 of file UnaryFunction.h.

## Member Function Documentation

## clone()

template<class T>

virtual Function< T > * casacore::UnaryFunction< T >::clone | ( |  | ) | const

inline virtual

Return a copy of this object from the heap.

The caller is responsible for deleting this pointer.

Implements casacore::Function< T, U >.

Definition at line 126 of file UnaryFunction.h.

References UnaryFunction().

## cloneAD()

template<class T>

virtual Function< typename FunctionTraits< T >::DiffType > * casacore::UnaryFunction< T >::cloneAD | ( |  | ) | const

inline virtual

Reimplemented from casacore::Function< T, U >.

Definition at line 127 of file UnaryFunction.h.

References UnaryFunction().

## cloneNonAD()

template<class T>

virtual Function< typename FunctionTraits< T >::BaseType > * casacore::UnaryFunction< T >::cloneNonAD | ( |  | ) | const

inline virtual

Reimplemented from casacore::Function< T, U >.

Definition at line 129 of file UnaryFunction.h.

References UnaryFunction().

## eval()

template<class T>

virtual T casacore::UnaryFunction< T >::eval | ( | typename Function< T >::FunctionArg | x | ) | const

virtual

Evaluate the Unary at x.

If a vector is used as the argument only its first element is used.

## operator=()

template<class T>

UnaryFunction< T > & casacore::UnaryFunction< T >::operator= | ( | const UnaryFunction< T > & | other | ) |

inline

Copy assignment (deep copy).

Definition at line 109 of file UnaryFunction.h.

References casacore::UnaryParam< T >::operator=(), and UnaryFunction().

The documentation for this class was generated from the following file:

- scimath/Functionals/UnaryFunction.h